#library "RANDMUS"
#include "zcommon.acs"

//#include "commonFuncs.h" // Even in making a silly music randomizer mod, I require ijon's funcs.

#define RANDOMMUS 461

int MusicRandomizerOn;
int MusicInfo;

int RandMusList[RANDOMMUS] = 
{
	"D_D1_11", // The Ultimate Doom
	"D_D1_12",
	"D_D1_13",
	"D_D1_14",
	"D_D1_15",
	"D_D1_16",
	"D_D1_17",
	"D_D1_18",
	"D_D1_19",
	"D_D1_21",
	"D_D1_22",
	"D_D1_23",
	"D_D1_24",
	"D_D1_26",
	"D_D1_27",
	"D_D1_28",
	"D_D1_31",
	"D_D1_32",
	"D_D1_33",
	"D_D1_38",
	"D_VICTOR",
	"D_D2_01", 	// Doom 2
	"D_D2_02",
	"D_D2_03",
	"D_D2_04",
	"D_D2_05",
	"D_D2_06",
	"D_D2_07",
	"D_D2_08",
	"D_D2_09",
	"D_D2_10",
	"D_D2_18",
	"D_D2_20",
	"D_D2_23",
	"D_D2_25",
	"D_D2_28",
	"D_D2_30",
	"D_D2_31",
	"D_D2_32",
	"D_D2_VIC",
	"D_TNT_01", // TNT Evilution
	"D_TNT_02",
	"D_TNT_04",
	"D_TNT_05",
	"D_TNT_06",
	"D_TNT_07",
	"D_TNT_08",
	"D_TNT_10",
	"D_TNT_11",
	"D_TNT_14",
	"D_TNT_16",
	"D_TNT_20",
	"D_TNT_22",
	"D_TNT_31",
	"D_HTP_01", // Hell to Pay / Perdition's Gate
	"D_HTP_02",
	"D_HTP_03",
	"D_HTP_04",
	"D_HTP_05",
	"D_HTP_06",
	"D_HTP_07",
	"D_HTP_08",
	"D_HTP_09",
	"D_HTP_10",
	"D_HTP_11", 
	"D_HTP_12",
	"D_HTP_13",
	"D_HTP_14",
	"D_HTP_15",
	"D_HTP_16",
	"D_HTP_17",
	"D_HTP_18",
	"D_HTP_19",
	"D_PG_01",
	"D_ADO_11", // 2002 ADO
	"D_ADO_12",
	"D_ADO_13",
	"D_ADO_14",
	"D_ADO_15",
	"D_ADO_16",
	"D_ADO_17",
	"D_ADO_18",
	"D_ADO_19",
	"D_ADO_21",
	"D_ADO_22",
	"D_ADO_23",
	"D_ADO_24",
	"D_ADO_25",
	"D_ADO_26",
	"D_ADO_27",
	"D_ADO_28",
	"D_ADO_29",
	"D_ADO_31",
	"D_ADO_32",
	"D_ADO_33",
	"D_ADO_34",
	"D_ADO_35",
	"D_ADO_36",
	"D_ADO_37",
	"D_ADO_38",
	"D_ADO_39",
	"D_ADO_41",
	"D_ADO_42",
	"D_ADO_43",
	"D_ADO_44",
	"D_ADO_45",
	"D_ADO_46",
	"D_ADO_47",
	"D_ADO_48",
	"D_ADO_49",
	"D_ED3_01", // Eternal Doom III
	"D_ED3_02",
	"D_ED3_03",
	"D_ED3_04",
	"D_ED3_05",
	"D_ED3_06",
	"D_ED3_07",
	"D_ED3_08",
	"D_ED3_09",
	"D_ED3_10",
	"D_ED3_11",
	"D_ED3_12",
	"D_ED3_13",
	"D_ED3_14",
	"D_ED3_15",
	"D_ED3_16",
	"D_ED3_17",
	"D_ED3_18",
	"D_ED3_19",
	"D_ED3_20",
	"D_ED3_21",
	"D_ED3_22",
	"D_ED3_23",
	"D_ED3_24",
	"D_ED3_25",
	"D_ED3_26",
	"D_ED3_27",
	"D_ED3_28",
	"D_ED3_29",
	"D_ED3_30",
	"D_ED3_31",
	"D_ED3_32",
	"D_HR2_01", // Hell Revealed II
	"D_HR2_02",
	"D_HR2_03",
	"D_HR2_04",
	"D_HR2_05",
	"D_HR2_06",
	"D_HR2_07",
	"D_HR2_08",
	"D_HR2_09",
	"D_HR2_10",
	"D_HR2_11",
	"D_HR2_12",
	"D_HR2_13",
	"D_HR2_14",
	"D_HR2_15",
	"D_HR2_16",
	"D_HR2_17",
	"D_HR2_18",
	"D_HR2_19",
	"D_HR2_20",
	"D_HR2_21",
	"D_HR2_22",
	"D_HR2_23",
	"D_HR2_24",
	"D_HR2_25",
	"D_HR2_26",
	"D_HR2_27",
	"D_HR2_28",
	"D_HR2_29",
	"D_HR2_30",
	"D_HR2_31",
	"D_HR2_32",
	"D_ICA_01",
	"D_ICA_02", // Icarus
	"D_ICA_03",
	"D_ICA_04",
	"D_ICA_05",
	"D_ICA_06",
	"D_ICA_07",
	"D_ICA_08",
	"D_ICA_09",
	"D_ICA_10",
	"D_ICA_11",
	"D_ICA_12",
	"D_ICA_13",
	"D_ICA_14",
	"D_ICA_15",
	"D_ICA_16",
	"D_ICA_17",
	"D_ICA_18",
	"D_ICA_19",
	"D_ICA_20",
	"D_ICA_21",
	"D_ICA_22",
	"D_ICA_23",
	"D_ICA_24",
	"D_ICA_25",
	"D_ICA_26",
	"D_ICA_27",
	"D_ICA_28",
	"D_ICA_29",
	"D_ICA_30",
	"D_ICA_31",
	"D_ICA_32",
	"D_MM_01", // Memento Mori
	"D_MM_02",
	"D_MM_03",
	"D_MM_04",
	"D_MM_05",
	"D_MM_06",
	"D_MM_07",
	"D_MM_08",
	"D_MM_09",
	"D_MM_10",
	"D_MM_11",
	"D_MM_12",
	"D_MM_13",
	"D_MM_14",
	"D_MM_15",
	"D_MM2_01", // Memento Mori 2
	"D_MM2_02",
	"D_MM2_03",
	"D_MM2_04",
	"D_MM2_05",
	"D_MM2_06",
	"D_MM2_07",
	"D_MM2_08",
	"D_MM2_09",
	"D_MM2_10",
	"D_MM2_11",
	"D_MM2_12",
	"D_MM2_13",
	"D_MM2_14",
	"D_MM2_15",
	"D_MM2_16",
	"D_MM2_17",
	"D_MM2_18",
	"D_MM2_19",
	"D_MM2_20",
	"D_MM2_21",
	"D_MM2_22",
	"D_MM2_23",
	"D_MM2_24",
	"D_MM2_25",
	"D_MM2_26",
	"D_MM2_27",
	"D_MM2_28",
	"D_MM2_29",
	"D_MM2_30",
	"D_MM2_31",
	"D_MM2_32",
	"D_REQ_01", // Requiem
	"D_REQ_02",
	"D_REQ_03",
	"D_REQ_04",
	"D_REQ_05",
	"D_REQ_06",
	"D_REQ_07",
	"D_REQ_08",
	"D_REQ_09",
	"D_REQ_10",
	"D_REQ_11",
	"D_REQ_12",
	"D_REQ_13",
	"D_REQ_14",
	"D_REQ_15",
	"D_REQ_16",
	"D_REQ_17",
	"D_REQ_18",
	"D_REQ_19",
	"D_REQ_20",
	"D_REQ_21",
	"D_REQ_24",
	"D_STR_01", // STRAIN
	"D_STR_02",
	"D_STR_03",
	"D_STR_04",
	"D_STR_05",
	"D_STR_06",
	"D_STR_07",
	"D_STR_08",
	"D_STR_09",
	"D_STR_10",
	"D_STR_11",
	"D_STR_12",
	"D_STR_13",
	"D_STR_14",
	"D_STR_16",
	"D_STR_17",
	"D_STR_19",
	"D_STR_20",
	"D_STR_21",
	"D_STR_26",
	"D_STR_27",
	"D_STR_28",
	"D_STR_32",
	"D_WOS_01", // Whispers of Satan
	"D_WOS_02",
	"D_WOS_03",
	"D_WOS_04",
	"D_WOS_05",
	"D_WOS_06",
	"D_WOS_07",
	"D_WOS_08",
	"D_WOS_09",
	"D_WOS_10",
	"D_WOS_11",
	"D_WOS_12",
	"D_WOS_13",
	"D_WOS_14",
	"D_WOS_15",
	"D_WOS_16",
	"D_WOS_17",
	"D_WOS_18",
	"D_WOS_19",
	"D_WOS_20",
	"D_WOS_21",
	"D_WOS_22",
	"D_WOS_23",
	"D_WOS_24",
	"D_WOS_25",
	"D_WOS_26",
	"D_WOS_27",
	"D_WOS_28",
	"D_WOS_29",
	"D_WOS_30",
	"D_WOS_31",
	"D_WOS_32",
	"D_WOS_33",
	"D_WOS_34",
	"D_WOS_35",
};

// Copied from ijon's commonfuncs.h
function int defaultCVar(int cvar, int defaultVal)
{
    int ret = GetCVar(cvar);
    if (ret == 0) { saveCVar(cvar, defaultVal); return defaultVal; }

    return ret;
}

function void saveCVar(int cvar, int val)
{
    int setStr = StrParam(s:"set ", s:cvar, s:" ", d:val);
    int arcStr = StrParam(s:"archivecvar ", s:cvar);
    ConsoleCommand(setStr); ConsoleCommand(arcStr);
}

// The Random Music Script Itself
Script 346 OPEN NET clientside
{
int i;
int randomhack;
int lastmus;
	if (GameType () != GAME_TITLE_MAP)
	{
    if (GetCvar("norandommusic") == 0)
    {
        MusicRandomizerOn = 1;
        if (GetCvar("mus_runninginzdoom") == 1)
        {
            i = random(0, RANDOMMUS-1);
            SetMusic(RandMusList[i],0);
        }
        else
        // Zandronum is funny about this. Online, it generates the same random seed every
        // time, even though that's the opposite of what you'd expect from a random call.
        // I have to use a workaround to generate pseudo-random behavior.
        // But it's better than dealing with ZDoom's barely-functional slapshod netcode!
        {
            randomhack = defaultCVar("mus_cl_randomhack",   0);
            lastmus    = defaultCVar("mus_cl_lastmusic",    0) - 1;

            for (i = 0; i < randomhack; i++) { random(0, 1); }
            randomhack = random(0, 500);
            SaveCVar("mus_cl_randomhack", randomhack);

            do { i = random(0, RANDOMMUS-1); }
            while (i == lastmus);

			SetMusic(RandMusList[i], 0);
            SaveCVar("mus_cl_lastmusic", i + 1);
        }
        Delay(35);
        if (GetCvar("nomusicinfo") == 0)
        {
            MusicInfo = strparam(s:"DESC_", s:RandMusList[i]);
            SetFont("TinyFont");
			SetHudSize(320,240,1);
            hudmessage(l:MusicInfo; HUDMSG_FADEINOUT | HUDMSG_LOG, 153, CR_WHITE, 6.1, 160.2, 3.0, 0.5, 1.0);
			hudmessage(l:MusicInfo; HUDMSG_FADEINOUT, 154, CR_BLACK, 7.1, 161.2, 3.0, 0.5, 1.0);
        }
    }
    else
    {
        MusicRandomizerOn = 0;
    }
	}
}

script 347 OPEN clientside
{
    delay(1);
    if (GetCvar("mus_runninginzdoom") == 0) // No option to disable on ZDoom because I'm pretty sure the only way this'll
    {                                       // be happening is when you manually load it, ergo want to listen to it...
        if (!GetCvar("norandommusic"))
            { ConsoleCommand("set norandommusic 0");
              ConsoleCommand("archivecvar norandommusic"); }
        if (!GetCvar("nomusicinfo"))
            { ConsoleCommand("set nomusicinfo 0");
              ConsoleCommand("archivecvar nomusicinfo"); }
    }
}

script 348 (int musicshit) NET clientside
{
int i;
int randomhack;
int lastmus;

switch (musicshit)
{
  case 0:
    SetMusic("silence");
    LocalAmbientSound("music/shift",127);
    Delay(35);
    if (GetCvar("norandommusic") == 0)
    {
        MusicRandomizerOn = 1;
        if (GetCvar("mus_runninginzdoom") == 1)
        {
            i = random(0, RANDOMMUS-1);
            SetMusic(RandMusList[i],0);
        }
        else
        {
            randomhack = defaultCVar("mus_cl_randomhack",   0);
            lastmus    = defaultCVar("mus_cl_lastmusic",    0) - 1;

            for (i = 0; i < randomhack; i++) { random(0, 1); }
            randomhack = random(0, 500);
            SaveCVar("mus_cl_randomhack", randomhack);

            do { i = random(0, RANDOMMUS-1); }
            while (i == lastmus);
            SetMusic(RandMusList[i], 0);
            SaveCVar("mus_cl_lastmusic", i + 1);
        }
        if (GetCvar("nomusicinfo") == 0)
        {
			MusicInfo = strparam(s:"DESC_", s:RandMusList[i]);
            SetFont("TinyFont");
			SetHudSize(320,240,0);
            hudmessage(l:MusicInfo; HUDMSG_FADEINOUT | HUDMSG_LOG, 153, CR_WHITE, 6.1, 160.2, 3.0, 0.5, 1.0);
			hudmessage(l:MusicInfo; HUDMSG_FADEINOUT, 154, CR_BLACK, 7.1, 161.2, 3.0, 0.5, 1.0);
        }
    }
    else
    {
        MusicRandomizerOn = 0;
        SetMusic("*",0);
    }
    break;

  case 1:
    SetMusic("silence");
    LocalAmbientSound("music/shift",127);
    Delay(35);
    SetMusic("*",0);
    break;
}
}